# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`barman`](#barman): === Authors  * Giuseppe Broccolo <giuseppe.broccolo@2ndQuadrant.it> * Giulio Calacoci <giulio.calacoci@2ndQuadrant.it> * Francesco Canovai <f
* [`barman::autoconfigure`](#barman--autoconfigure): == Class: barman  This class:  * Creates the .pgpass file for the 'barman' user * Imports resources exported by PostgreSQL server ** to set c
* [`barman::postgres`](#barman--postgres): This class export resources to the Barman server (Barman configurations,

### Defined types

* [`barman::archive_command`](#barman--archive_command): Build the correct archive command which will be exported to the PostgreSQL server
* [`barman::server`](#barman--server): Creates a barman configuration for a postgresql instance.

### Data types

* [`Barman::BackupAge`](#Barman--BackupAge): Allowed backup age
* [`Barman::BackupMethod`](#Barman--BackupMethod): Barman backup methods
* [`Barman::BackupOptions`](#Barman--BackupOptions): Barman backup options
* [`Barman::BackupSize`](#Barman--BackupSize): Allowed backup size
* [`Barman::CreateSlot`](#Barman--CreateSlot): Allowed values for `create_slot` option
* [`Barman::LogLevel`](#Barman--LogLevel): Allowed log levels
* [`Barman::Password`](#Barman--Password): Allowed values for secrets
* [`Barman::RecoveryOptions`](#Barman--RecoveryOptions): Recovery options, currently only `get-wal` supported
* [`Barman::RetentionPolicy`](#Barman--RetentionPolicy): Backup's retention policy
* [`Barman::RetentionPolicyMode`](#Barman--RetentionPolicyMode): Retention policy mode
* [`Barman::ReuseBackup`](#Barman--ReuseBackup): Methods for reusing backups
* [`Barman::ServerName`](#Barman--ServerName): Allowed characters for server name
* [`Barman::WalRetention`](#Barman--WalRetention): WAL retention

## Classes

### <a name="barman"></a>`barman`

=== Authors

* Giuseppe Broccolo <giuseppe.broccolo@2ndQuadrant.it>
* Giulio Calacoci <giulio.calacoci@2ndQuadrant.it>
* Francesco Canovai <francesco.canovai@2ndQuadrant.it>
* Marco Nenciarini <marco.nenciarini@2ndQuadrant.it>
* Gabriele Bartolini <gabriele.bartolini@2ndQuadrant.it>
* Alessandro Grassi <alessandro.grassi@2ndQuadrant.it>

Many thanks to Alessandro Franceschi <al@lab42.it>

=== Copyright

Copyright 2012-2017 2ndQuadrant Italia

This option allows you to enable data compression for network transfers. Defaults to false.
One or more absolute paths, separated by colon, where Barman
                  looks for executable files.
Hook script launched after a WAL file is
                                archived by maintenance. Being this a retry hook
                                script, Barman will retry the execution of the
                                script until this either returns a SUCCESS (0),
                                an ABORT_CONTINUE (62) or an ABORT_STOP (63)
                                code. In a post archive scenario, ABORT_STOP has
                                currently the same effects as ABORT_CONTINUE.
Hook script launched after a WAL file is archived by
                          maintenance, after 'post_archive_retry_script'.
Hook script launched after a base backup. Being
                               this a retry hook script, Barman will retry the
                               execution of the script until this either returns
                               a SUCCESS (0), an ABORT_CONTINUE (62) or an
                               ABORT_STOP (63) code. In a post backup scenario,
                               ABORT_STOP has currently the same effects as
                               ABORT_CONTINUE.
Hook script launched after a base backup, after
                         'post_backup_retry_script'.
Hook script launched before a WAL file is
                               archived by maintenance, after
                               'pre_archive_script'. Being this a retry hook
                               script, Barman will retry the execution of the
                               script until this either returns a SUCCESS (0),
                               an ABORT_CONTINUE (62) or an ABORT_STOP (63)
                               code. Returning ABORT_STOP will propagate the
                               failure at a higher level and interrupt the WAL
                               archiving operation.
Hook script launched before a WAL file is archived by
			   maintenance.
Hook script launched before a base backup, after
                              'pre_backup_script'. Being this a retry hook
                              script, Barman will retry the execution of the
                              script until this either returns a SUCCESS (0), an
                              ABORT_CONTINUE (62) or an ABORT_STOP (63) code.
                              Returning ABORT_STOP will propagate the failure at
                              a higher level and interrupt the backup operation.
Hook script launched before a base backup.
Base backup retention policy, based on redundancy or
                       recovery window. Default empty (no retention enforced).
                       Value must be greater than or equal to the server
                       minimum redundancy level (if not is is assigned to
                       that value and a warning is generated).
WAL archive logs retention policy. Currently, the
                           only allowed value for wal_retention_policy is the
                           special value main, that maps the retention policy
                           of archive logs to that of base backups.
Can only be set to auto (retention policies are
                            automatically enforced by the barman cron command)
Incremental backup is a kind of full periodic backup which
                   saves only data changes from the latest full backup
                   available in the catalogue for a specific PostgreSQL
                   server. Disabled if false. Default false.
Physical replication slot to be used by the receive-wal
                command when streaming_archiver is set to on. Requires
                postgreSQL >= 9.4. Default: undef (disabled).
This option allows you to use the PostgreSQL's
                         streaming protocol to receive transaction logs from a
                         server. This activates connection checks as well as
                         management (including compression) of WAL files. If
                         set to off (default) barman will rely only on
                         continuous archiving for a server WAL archive
                         operations, eventually terminating any running
                         pg_receivexlog for the server.
This option allows you to activate batch
                                    processing of WAL files for the
                                    streaming_archiver process, by setting it to
                                    a value > 0. Otherwise, the traditional
                                    unlimited processing of the WAL queue is
                                    enabled.
Identifier to be used as application_name by the
                              receive-wal command. Only available with
                              pg_receivexlog >= 9.3. By default it is set to
                              barman_receive_wal.
Identifier to be used as application_name by the
                            pg_basebackup command. Only available with
                            pg_basebackup >= 9.3. By default it is set to
                            barman_streaming_backup.
Directory where WAL files are streamed from the
                               PostgreSQL server to Barman.
This option allows you to specify a maximum
                                 transfer rate in kilobytes per second, by
                                 specifying a comma separated list of
                                 tablespaces (pairs TBNAME:BWLIMIT). A value of
                                 zero specifies no limit (default).
DEPRECATED. Custom configuration directives (e.g. for
                   custom compression). Defaults to empty.
The fqdn of the Barman server. It will be exported in
                  several resources in the PostgreSQL server. Puppet
                  automatically set this.
This is the main parameter to enable the
                    autoconfiguration of the backup of a given PostgreSQL
                    server. Defaults to false.
The ipaddress exported to the PostgreSQL server
                         during atutoconfiguration. Defaults to
                         "${::ipaddress}/32".
Configure PGDG repository. It is implemented
                          internally by declaring the `postgresql::globals`
                          class. If you need to customize the
                          `postgresql::globals` class declaration, keep the
                          `manage_package_repo` parameter disabled in `barman`
                          module and enable it directly in
                          `postgresql::globals` class.
When using autoconfigure, ensure the hosts contain
                           each other ssh host key. Must also be set on
                           'barman::postgres' class. Defaults to false.
Whether or not barman conf files not included in
                         puppetdb will be removed by puppet.
hiera hash to support the server define.
              Defaults to undef.

#### Examples

##### The class can be used right away with defaults:

```puppet

include barman
```

##### All parameters that are supported by barman can be changed:

```puppet
class { barman:
  logfile  => '/var/log/barman/something_else.log',
  compression => 'bzip2',
  pre_backup_script => '/usr/bin/touch /tmp/started',
  post_backup_script => '/usr/bin/touch /tmp/stopped',
  custom_lines => '; something'
}
```

#### Parameters

The following parameters are available in the `barman` class:

* [`user`](#-barman--user)
* [`group`](#-barman--group)
* [`ensure`](#-barman--ensure)
* [`dbuser`](#-barman--dbuser)
* [`dbname`](#-barman--dbname)
* [`conf_file_path`](#-barman--conf_file_path)
* [`conf_template`](#-barman--conf_template)
* [`logrotate_template`](#-barman--logrotate_template)
* [`home`](#-barman--home)
* [`home_mode`](#-barman--home_mode)
* [`logfile`](#-barman--logfile)
* [`log_level`](#-barman--log_level)
* [`archiver`](#-barman--archiver)
* [`archive_cmd_type`](#-barman--archive_cmd_type)
* [`hba_entry_order`](#-barman--hba_entry_order)
* [`archiver_batch_size`](#-barman--archiver_batch_size)
* [`backup_method`](#-barman--backup_method)
* [`backup_options`](#-barman--backup_options)
* [`recovery_options`](#-barman--recovery_options)
* [`bandwidth_limit`](#-barman--bandwidth_limit)
* [`barman_lock_directory`](#-barman--barman_lock_directory)
* [`check_timeout`](#-barman--check_timeout)
* [`compression`](#-barman--compression)
* [`create_slot`](#-barman--create_slot)
* [`custom_compression_filter`](#-barman--custom_compression_filter)
* [`custom_decompression_filter`](#-barman--custom_decompression_filter)
* [`immediate_checkpoint`](#-barman--immediate_checkpoint)
* [`basebackup_retry_times`](#-barman--basebackup_retry_times)
* [`basebackup_retry_sleep`](#-barman--basebackup_retry_sleep)
* [`minimum_redundancy`](#-barman--minimum_redundancy)
* [`network_compression`](#-barman--network_compression)
* [`parallel_jobs`](#-barman--parallel_jobs)
* [`path_prefix`](#-barman--path_prefix)
* [`last_backup_maximum_age`](#-barman--last_backup_maximum_age)
* [`last_wal_maximum_age`](#-barman--last_wal_maximum_age)
* [`last_backup_minimum_size`](#-barman--last_backup_minimum_size)
* [`post_archive_retry_script`](#-barman--post_archive_retry_script)
* [`post_archive_script`](#-barman--post_archive_script)
* [`post_backup_retry_script`](#-barman--post_backup_retry_script)
* [`post_backup_script`](#-barman--post_backup_script)
* [`pre_archive_retry_script`](#-barman--pre_archive_retry_script)
* [`pre_archive_script`](#-barman--pre_archive_script)
* [`pre_backup_retry_script`](#-barman--pre_backup_retry_script)
* [`pre_backup_script`](#-barman--pre_backup_script)
* [`retention_policy`](#-barman--retention_policy)
* [`wal_retention_policy`](#-barman--wal_retention_policy)
* [`retention_policy_mode`](#-barman--retention_policy_mode)
* [`reuse_backup`](#-barman--reuse_backup)
* [`slot_name`](#-barman--slot_name)
* [`streaming_archiver`](#-barman--streaming_archiver)
* [`streaming_archiver_batch_size`](#-barman--streaming_archiver_batch_size)
* [`streaming_archiver_name`](#-barman--streaming_archiver_name)
* [`streaming_backup_name`](#-barman--streaming_backup_name)
* [`streaming_wals_directory`](#-barman--streaming_wals_directory)
* [`tablespace_bandwidth_limit`](#-barman--tablespace_bandwidth_limit)
* [`custom_lines`](#-barman--custom_lines)
* [`barman_fqdn`](#-barman--barman_fqdn)
* [`autoconfigure`](#-barman--autoconfigure)
* [`exported_ipaddress`](#-barman--exported_ipaddress)
* [`host_group`](#-barman--host_group)
* [`manage_package_repo`](#-barman--manage_package_repo)
* [`manage_ssh_host_keys`](#-barman--manage_ssh_host_keys)
* [`purge_unknown_conf`](#-barman--purge_unknown_conf)
* [`servers`](#-barman--servers)

##### <a name="-barman--user"></a>`user`

Data type: `String`

The Barman user. Default `barman`.

##### <a name="-barman--group"></a>`group`

Data type: `String`

The group of the Barman user

##### <a name="-barman--ensure"></a>`ensure`

Data type: `String`

Ensure that Barman is installed. The default value is 'present'.
Otherwise it will be set as 'absent'.

##### <a name="-barman--dbuser"></a>`dbuser`

Data type: `String`

Username used for connecting to the database

##### <a name="-barman--dbname"></a>`dbname`

Data type: `String`



##### <a name="-barman--conf_file_path"></a>`conf_file_path`

Data type: `String`

Absolute path to main `barman.conf` file

Default value: `$barman::conf_file_path`

##### <a name="-barman--conf_template"></a>`conf_template`

Data type: `String`

Path of the template of the barman.conf configuration
 file. The default value does not need to be changed.

Default value: `'barman/barman.conf.erb'`

##### <a name="-barman--logrotate_template"></a>`logrotate_template`

Data type: `String`

Path of the template of the logrotate.conf file.
The default value does not need to be changed.

Default value: `'barman/logrotate.conf.erb'`

##### <a name="-barman--home"></a>`home`

Data type: `Stdlib::Absolutepath`

A different place for backups than the default. Will be symlinked
to the default (/var/lib/barman). You should not change this
  value after the first setup.

##### <a name="-barman--home_mode"></a>`home_mode`

Data type: `String`

Directory mode, default: `0750`

##### <a name="-barman--logfile"></a>`logfile`

Data type: `Stdlib::Absolutepath`

A different log file. The default is '/var/log/barman/barman.log'

##### <a name="-barman--log_level"></a>`log_level`

Data type: `Barman::LogLevel`

Level of logging. The default is INFO
(DEBUG, INFO, WARNING, ERROR, CRITICAL). Global.

##### <a name="-barman--archiver"></a>`archiver`

Data type: `Boolean`

Whether the log shipping backup mechanism is active or not (defaults to true)

##### <a name="-barman--archive_cmd_type"></a>`archive_cmd_type`

Data type: `String`

Default `rsync`

##### <a name="-barman--hba_entry_order"></a>`hba_entry_order`

Data type: `Integer`

Entry priority

##### <a name="-barman--archiver_batch_size"></a>`archiver_batch_size`

Data type: `Optional[Integer]`

Setting this option enables batch processing of WAL files.
The default processes all currently available files.

Default value: `undef`

##### <a name="-barman--backup_method"></a>`backup_method`

Data type: `Barman::BackupMethod`

Configure the method barman used for backup execution. If set to rsync (default),
barman will execute backup using the rsync command. If set to postgres barman will use the
pg_basebackup command to execute the backup.

Default value: `undef`

##### <a name="-barman--backup_options"></a>`backup_options`

Data type: `Barman::BackupOptions`

Behavior for backup operations: possible values are exclusive_backup (default) and concurrent_backup.

Default value: `undef`

##### <a name="-barman--recovery_options"></a>`recovery_options`

Data type: `Barman::RecoveryOptions`

The restore command to write in the recovery.conf.
Possible values are 'get-wal' and undef. Default: undef.

Default value: `undef`

##### <a name="-barman--bandwidth_limit"></a>`bandwidth_limit`

Data type: `Optional[Integer]`

This option allows you to specify a maximum transfer rate in kilobytes per second.
A value of zero specifies no limit (default).

Default value: `undef`

##### <a name="-barman--barman_lock_directory"></a>`barman_lock_directory`

Data type: `Optional[String]`

Global option for a directory for lock files.

Default value: `undef`

##### <a name="-barman--check_timeout"></a>`check_timeout`

Data type: `Optional[Integer]`

Maximum execution time, in seconds per server, for a barman
check command. Set to 0 to disable the timeout. Positive integer, default 30.

Default value: `undef`

##### <a name="-barman--compression"></a>`compression`

Data type: `Variant[String,Boolean]`

Compression algorithm. Currently supports 'gzip' (default),
'bzip2', and 'custom'. Disabled if false.

##### <a name="-barman--create_slot"></a>`create_slot`

Data type: `Barman::CreateSlot`

Determines whether Barman should automatically create a replication slot if it’s
not already present for streaming WAL files. One of 'auto' or 'manual' (default).

Default value: `undef`

##### <a name="-barman--custom_compression_filter"></a>`custom_compression_filter`

Data type: `Optional[String]`

Customised compression algorithm applied to WAL files.

Default value: `undef`

##### <a name="-barman--custom_decompression_filter"></a>`custom_decompression_filter`

Data type: `Optional[String]`

Customised decompression algorithm applied to compressed WAL files; this must match the
compression algorithm.

Default value: `undef`

##### <a name="-barman--immediate_checkpoint"></a>`immediate_checkpoint`

Data type: `Boolean`

Force the checkpoint on the Postgres server to happen immediately and start your backup copy
process as soon as possible. Disabled if false (default)

##### <a name="-barman--basebackup_retry_times"></a>`basebackup_retry_times`

Data type: `Optional[Integer]`

Number of retries fo data copy during base backup after an error. Default = 0

Default value: `undef`

##### <a name="-barman--basebackup_retry_sleep"></a>`basebackup_retry_sleep`

Data type: `Optional[Integer]`

Number of seconds to wait after after a failed copy, before retrying. Default = 30

Default value: `undef`

##### <a name="-barman--minimum_redundancy"></a>`minimum_redundancy`

Data type: `Integer`

Minimum number of required backups (redundancy). Default = 0

##### <a name="-barman--network_compression"></a>`network_compression`

Data type: `Optional[Boolean]`



Default value: `undef`

##### <a name="-barman--parallel_jobs"></a>`parallel_jobs`

Data type: `Optional[Integer]`

Number of parallel workers used to copy files during backup or recovery. Requires backup mode = rsync.

Default value: `undef`

##### <a name="-barman--path_prefix"></a>`path_prefix`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-barman--last_backup_maximum_age"></a>`last_backup_maximum_age`

Data type: `Barman::BackupAge`

Defines the time frame within which the latest backup must fall. If the latest
backup is older than this period, the barman check command will report an
error. If left empty (default), the latest backup is always considered valid.
The accepted format is "n {DAYS|WEEKS|MONTHS}", where n is an integer greater
than zero.

Default value: `undef`

##### <a name="-barman--last_wal_maximum_age"></a>`last_wal_maximum_age`

Data type: `Barman::BackupAge`

Defines the time frame within which the latest archived WAL file must fall. If
the latest WAL file is older than this period, the barman check command will
report an error. If left empty (default), the age of the WAL files is not
checked. Format is the same as last_backup_maximum_age.

Default value: `undef`

##### <a name="-barman--last_backup_minimum_size"></a>`last_backup_minimum_size`

Data type: `Barman::BackupSize`

Specifies the minimum acceptable size for the latest successful backup. If the
latest backup is smaller than this size, the barman check command will report
an error. If left empty (default), the latest backup is always considered
valid. The accepted format is "n {k|Ki|M|Mi|G|Gi|T|Ti}" and case-sensitive,
where n is an integer greater than zero, with an optional SI or IEC suffix.
k stands for kilo with k = 1000, while Ki stands for kilobytes Ki = 1024. The
rest of the options have the same reasoning for greater units of measure.

Default value: `undef`

##### <a name="-barman--post_archive_retry_script"></a>`post_archive_retry_script`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-barman--post_archive_script"></a>`post_archive_script`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-barman--post_backup_retry_script"></a>`post_backup_retry_script`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-barman--post_backup_script"></a>`post_backup_script`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-barman--pre_archive_retry_script"></a>`pre_archive_retry_script`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-barman--pre_archive_script"></a>`pre_archive_script`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-barman--pre_backup_retry_script"></a>`pre_backup_retry_script`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-barman--pre_backup_script"></a>`pre_backup_script`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-barman--retention_policy"></a>`retention_policy`

Data type: `Barman::RetentionPolicy`



Default value: `undef`

##### <a name="-barman--wal_retention_policy"></a>`wal_retention_policy`

Data type: `Barman::WalRetention`



Default value: `undef`

##### <a name="-barman--retention_policy_mode"></a>`retention_policy_mode`

Data type: `Barman::RetentionPolicyMode`



Default value: `undef`

##### <a name="-barman--reuse_backup"></a>`reuse_backup`

Data type: `Barman::ReuseBackup`



Default value: `undef`

##### <a name="-barman--slot_name"></a>`slot_name`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-barman--streaming_archiver"></a>`streaming_archiver`

Data type: `Boolean`



##### <a name="-barman--streaming_archiver_batch_size"></a>`streaming_archiver_batch_size`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-barman--streaming_archiver_name"></a>`streaming_archiver_name`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-barman--streaming_backup_name"></a>`streaming_backup_name`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-barman--streaming_wals_directory"></a>`streaming_wals_directory`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-barman--tablespace_bandwidth_limit"></a>`tablespace_bandwidth_limit`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-barman--custom_lines"></a>`custom_lines`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-barman--barman_fqdn"></a>`barman_fqdn`

Data type: `String`



Default value: `$facts['networking']['fqdn']`

##### <a name="-barman--autoconfigure"></a>`autoconfigure`

Data type: `Boolean`



##### <a name="-barman--exported_ipaddress"></a>`exported_ipaddress`

Data type: `Stdlib::IP::Address`



Default value: `"${facts['networking']['ip']}/32"`

##### <a name="-barman--host_group"></a>`host_group`

Data type: `String`

Tag used to collect and export resources during
                 autoconfiguration. Defaults to 'global'.

##### <a name="-barman--manage_package_repo"></a>`manage_package_repo`

Data type: `Boolean`



##### <a name="-barman--manage_ssh_host_keys"></a>`manage_ssh_host_keys`

Data type: `Boolean`



##### <a name="-barman--purge_unknown_conf"></a>`purge_unknown_conf`

Data type: `Boolean`



##### <a name="-barman--servers"></a>`servers`

Data type: `Optional[Hash]`



Default value: `undef`

### <a name="barman--autoconfigure"></a>`barman::autoconfigure`

== Class: barman

This class:

* Creates the .pgpass file for the 'barman' user
* Imports resources exported by PostgreSQL server
** to set cron
** to import SSH key of 'postgres' user
** to fill the .pgpass file
** to configure Barman (fill .conf files)
* Exports Barman resources to the PostgreSQL server
** to set the 'archive_command' in postgresql.conf
** to export the SSH key of 'barman' user
** to configure the pg_hba.conf

=== Parameters

=== Authors

* Giuseppe Broccolo <giuseppe.broccolo@2ndQuadrant.it>
* Giulio Calacoci <giulio.calacoci@2ndQuadrant.it>
* Francesco Canovai <francesco.canovai@2ndQuadrant.it>
* Marco Nenciarini <marco.nenciarini@2ndQuadrant.it>
* Gabriele Bartolini <gabriele.bartolini@2ndQuadrant.it>
* Alessandro Grassi <alessandro.grassi@2ndQuadrant.it>

Many thanks to Alessandro Franceschi <al@lab42.it>

=== Copyright

Copyright 2012-2017 2ndQuadrant Italia

#### Parameters

The following parameters are available in the `barman::autoconfigure` class:

* [`host_group`](#-barman--autoconfigure--host_group)
* [`exported_ipaddress`](#-barman--autoconfigure--exported_ipaddress)
* [`archive_cmd_type`](#-barman--autoconfigure--archive_cmd_type)

##### <a name="-barman--autoconfigure--host_group"></a>`host_group`

Data type: `String`

Tag the different host groups for the backup
(default value is set from the 'settings' class).

Default value: `$barman::host_group`

##### <a name="-barman--autoconfigure--exported_ipaddress"></a>`exported_ipaddress`

Data type: `Stdlib::IP::Address`

The barman server address to allow in the PostgreSQL
server ph_hba.conf. Defaults to "${::ipaddress}/32".

Default value: `"${facts['networking']['ip']}/32"`

##### <a name="-barman--autoconfigure--archive_cmd_type"></a>`archive_cmd_type`

Data type: `String`

The archive command to use - either rsync (default) or
barman-wal-archive

Default value: `'rsync'`

### <a name="barman--postgres"></a>`barman::postgres`

cron, SSH key) and import resources from it (configure 'archive_mode',
define user used by Barman to connect into PostgreSQL database(s)).

=== Authors

* Giuseppe Broccolo <giuseppe.broccolo@2ndQuadrant.it>
* Giulio Calacoci <giulio.calacoci@2ndQuadrant.it>
* Francesco Canovai <francesco.canovai@2ndQuadrant.it>
* Marco Nenciarini <marco.nenciarini@2ndQuadrant.it>
* Gabriele Bartolini <gabriele.bartolini@2ndQuadrant.it>
* Alessandro Grassi <alessandro.grassi@2ndQuadrant.it>

Many thanks to Alessandro Franceschi <al@lab42.it>

=== Copyright

Copyright 2012-2017 2ndQuadrant Italia

Tag the different host groups for the backup
                 (default value is set from the 'settings' class).
When using autoconfigure, ensure the hosts contain
                           each other ssh host key. Must also be set on 'barman'
                           class. Defaults to false.
Configuration of the 'wal_level' parameter in the
                postgresql.conf file. The default value is 'archive'.
Definition of the 'barman' user used in Barman 'conninfo'.
                  The default value is set from the 'settings' class.
Definition of the user used by Barman to connect to the
                    PostgreSQL database(s) in the 'conninfo'. The default
                    value is set from the 'settings' class.
Definition of the barman home directory. The default value
                  is set from the 'settings' class.
Whether cron entry should be managed.
User to run cron jobs.
Day of the month set in the cron for the backup schedule.
                  The default value (undef) ensure daily backups.
Day of the week set in the cron for the backup schedule.
                  The default value (undef) ensure daily backups.
Hour set in the cron for the backup schedule. The default
                  value is 04:XXam.
Minute set in the cron for the backup schedule. The
                    default value is for XX:00am
Password used by Barman to connect to PosgreSQL. The default
               value (empty string) allows the generation of a random
               password.
The whole fqdn of the PostgreSQL server used in Barman
                     'ssh_command' (automatically configured by Puppet).
The port used by PostgreSQL for receiving connections
                  (default: 5432)
Id of the PostgreSQL server, given by its host name
                         (automatically configured by Puppet).
The PostgreSQL user used in Barman 'ssh_command'.
Ensure (or not) that single server Barman configuration files are
             created. The default value is 'present'. Just 'absent' or
             'present' are the possible settings.
path of the template file to build the Barman
                    configuration file.
Description of the configuration file: it is automatically
                  set when the resource is used.
Whether the log shipping backup mechanism is active or not.
Setting this option enables batch processing of WAL
                          files. The default processes all currently available
                          files.
Directory where backup data for a server will be placed.
Configure the method barman used for backup execution. If
                    set to rsync (default), barman will execute backup using the
                    rsync command. If set to postgres barman will use the
                    pg_basebackup command to execute the backup.
Behavior for backup operations: possible values are
                     exclusive_backup (default) and concurrent_backup.
The restore command to write in the recovery.conf.
                       Possible values are 'get-wal' and undef. Default: undef.
This option allows you to specify a maximum transfer rate
                      in kilobytes per second. A value of zero specifies no
                      limit (default).
Directory where base backups will be placed.
Number of seconds of wait after a failed copy,
                             before retrying Used during both backup and
                             recovery operations. Positive integer, default 30.
Number of retries of base backup copy, after an
                             error. Used during both backup and recovery
                             operations. Positive integer, default 0.
Maximum execution time, in seconds per server, for a barman
                    check command. Set to 0 to disable the timeout. Positive
                    integer, default 30.
Compression algorithm. Currently supports 'gzip' (default),
                  'bzip2', and 'custom'. Disabled if false.
Customised compression algorithm applied to WAL
                                files.
Customised decompression algorithm applied to
                                  compressed WAL files; this must match the
                                  compression algorithm.
Directory that contains WAL files that contain an error.
Force the checkpoint on the Postgres server to
                           happen immediately and start your backup copy
                           process as soon as possible. Disabled if false
                           (default)
Directory where incoming WAL files are archived
                              into. Requires archiver to be enabled.
Minimum number of backups to be retained. Default 0.
This option allows you to enable data compression for
                          network transfers. Defaults to false.
One or more absolute paths, separated by colon, where Barman
                  looks for executable files.
Hook script launched after a WAL file is
                                archived by maintenance. Being this a retry hook
                                script, Barman will retry the execution of the
                                script until this either returns a SUCCESS (0),
                                an ABORT_CONTINUE (62) or an ABORT_STOP (63)
                                code. In a post archive scenario, ABORT_STOP has
                                currently the same effects as ABORT_CONTINUE.
Hook script launched after a WAL file is archived by
                          maintenance, after 'post_archive_retry_script'.
Hook script launched after a base backup. Being
                               this a retry hook script, Barman will retry the
                               execution of the script until this either returns
                               a SUCCESS (0), an ABORT_CONTINUE (62) or an
                               ABORT_STOP (63) code. In a post backup scenario,
                               ABORT_STOP has currently the same effects as
                               ABORT_CONTINUE.
Hook script launched after a base backup, after
                         'post_backup_retry_script'.
Hook script launched before a WAL file is
                               archived by maintenance, after
                               'pre_archive_script'. Being this a retry hook
                               script, Barman will retry the execution of the
                               script until this either returns a SUCCESS (0),
                               an ABORT_CONTINUE (62) or an ABORT_STOP (63)
                               code. Returning ABORT_STOP will propagate the
                               failure at a higher level and interrupt the WAL
                               archiving operation.
Hook script launched before a WAL file is archived by
                         maintenance.
Hook script launched before a base backup, after
                              'pre_backup_script'. Being this a retry hook
                              script, Barman will retry the execution of the
                              script until this either returns a SUCCESS (0), an
                              ABORT_CONTINUE (62) or an ABORT_STOP (63) code.
                              Returning ABORT_STOP will propagate the failure at
                              a higher level and interrupt the backup operation.
Hook script launched before a base backup.
Base backup retention policy, based on redundancy or
                       recovery window. Default empty (no retention enforced).
                       Value must be greater than or equal to the server
                       minimum redundancy level (if not is is assigned to
                       that value and a warning is generated).
Can only be set to auto (retention policies are
                            automatically enforced by the barman cron command)
Incremental backup is a kind of full periodic backup which
                   saves only data changes from the latest full backup
                   available in the catalogue for a specific PostgreSQL
                   server. Disabled if false. Default false.
Physical replication slot to be used by the receive-wal
                command when streaming_archiver is set to on. Requires
                postgreSQL >= 9.4. Default: undef (disabled).
This option allows you to use the PostgreSQL's
                         streaming protocol to receive transaction logs from a
                         server. This activates connection checks as well as
                         management (including compression) of WAL files. If
                         set to off (default) barman will rely only on
                         continuous archiving for a server WAL archive
                         operations, eventually terminating any running
                         pg_receivexlog for the server.
This option allows you to activate batch
                                    processing of WAL files for the
                                    streaming_archiver process, by setting it to
                                    a value > 0. Otherwise, the traditional
                                    unlimited processing of the WAL queue is
                                    enabled.
Identifier to be used as application_name by the
                              receive-wal command. Only available with
                              pg_receivexlog >= 9.3. By default it is set to
                              barman_receive_wal.
Identifier to be used as application_name by the
                            pg_basebackup command. Only available with
                            pg_basebackup >= 9.3. By default it is set to
                            barman_streaming_backup.
Connection string used by Barman to connect to the
                         Postgres server via streaming replication protocol. By
                         default it is set to the same value as *conninfo*.
Directory where WAL files are streamed from the
                               PostgreSQL server to Barman.
This option allows you to specify a maximum
                                 transfer rate in kilobytes per second, by
                                 specifying a comma separated list of
                                 tablespaces (pairs TBNAME:BWLIMIT). A value of
                                 zero specifies no limit (default).
WAL archive logs retention policy. Currently, the
                           only allowed value for wal_retention_policy is the
                           special value main, that maps the retention policy
                           of archive logs to that of base backups.
Directory which contains WAL files.

#### Examples

##### The class can be used right away with defaults:

```puppet
include postgres
```

##### All parameters that are supported by barman can be changed:

```puppet
class { postgres :
  backup_hour   => 4,
  backup_minute => 0,
  password      => 'not_needed',
  postgres_user => 'postgres',
}
```

#### Parameters

The following parameters are available in the `barman::postgres` class:

* [`manage_barman_server`](#-barman--postgres--manage_barman_server)
* [`host_group`](#-barman--postgres--host_group)
* [`manage_dbuser`](#-barman--postgres--manage_dbuser)
* [`manage_ssh_host_keys`](#-barman--postgres--manage_ssh_host_keys)
* [`wal_level`](#-barman--postgres--wal_level)
* [`barman_user`](#-barman--postgres--barman_user)
* [`barman_dbname`](#-barman--postgres--barman_dbname)
* [`barman_dbuser`](#-barman--postgres--barman_dbuser)
* [`barman_home`](#-barman--postgres--barman_home)
* [`manage_cron`](#-barman--postgres--manage_cron)
* [`cron_user`](#-barman--postgres--cron_user)
* [`backup_mday`](#-barman--postgres--backup_mday)
* [`backup_wday`](#-barman--postgres--backup_wday)
* [`backup_hour`](#-barman--postgres--backup_hour)
* [`backup_minute`](#-barman--postgres--backup_minute)
* [`password`](#-barman--postgres--password)
* [`server_address`](#-barman--postgres--server_address)
* [`server_port`](#-barman--postgres--server_port)
* [`postgres_server_id`](#-barman--postgres--postgres_server_id)
* [`postgres_user`](#-barman--postgres--postgres_user)
* [`ensure`](#-barman--postgres--ensure)
* [`conf_template`](#-barman--postgres--conf_template)
* [`description`](#-barman--postgres--description)
* [`archiver`](#-barman--postgres--archiver)
* [`force_archive_mode`](#-barman--postgres--force_archive_mode)
* [`archiver_batch_size`](#-barman--postgres--archiver_batch_size)
* [`backup_directory`](#-barman--postgres--backup_directory)
* [`backup_method`](#-barman--postgres--backup_method)
* [`backup_options`](#-barman--postgres--backup_options)
* [`recovery_options`](#-barman--postgres--recovery_options)
* [`bandwidth_limit`](#-barman--postgres--bandwidth_limit)
* [`basebackups_directory`](#-barman--postgres--basebackups_directory)
* [`basebackup_retry_sleep`](#-barman--postgres--basebackup_retry_sleep)
* [`basebackup_retry_times`](#-barman--postgres--basebackup_retry_times)
* [`check_timeout`](#-barman--postgres--check_timeout)
* [`compression`](#-barman--postgres--compression)
* [`custom_compression_filter`](#-barman--postgres--custom_compression_filter)
* [`custom_decompression_filter`](#-barman--postgres--custom_decompression_filter)
* [`errors_directory`](#-barman--postgres--errors_directory)
* [`immediate_checkpoint`](#-barman--postgres--immediate_checkpoint)
* [`incoming_wals_directory`](#-barman--postgres--incoming_wals_directory)
* [`last_backup_maximum_age`](#-barman--postgres--last_backup_maximum_age)
* [`last_wal_maximum_age`](#-barman--postgres--last_wal_maximum_age)
* [`last_backup_minimum_size`](#-barman--postgres--last_backup_minimum_size)
* [`minimum_redundancy`](#-barman--postgres--minimum_redundancy)
* [`network_compression`](#-barman--postgres--network_compression)
* [`parallel_jobs`](#-barman--postgres--parallel_jobs)
* [`path_prefix`](#-barman--postgres--path_prefix)
* [`post_archive_retry_script`](#-barman--postgres--post_archive_retry_script)
* [`post_archive_script`](#-barman--postgres--post_archive_script)
* [`post_backup_retry_script`](#-barman--postgres--post_backup_retry_script)
* [`post_backup_script`](#-barman--postgres--post_backup_script)
* [`pre_archive_retry_script`](#-barman--postgres--pre_archive_retry_script)
* [`pre_archive_script`](#-barman--postgres--pre_archive_script)
* [`pre_backup_retry_script`](#-barman--postgres--pre_backup_retry_script)
* [`pre_backup_script`](#-barman--postgres--pre_backup_script)
* [`retention_policy`](#-barman--postgres--retention_policy)
* [`retention_policy_mode`](#-barman--postgres--retention_policy_mode)
* [`reuse_backup`](#-barman--postgres--reuse_backup)
* [`slot_name`](#-barman--postgres--slot_name)
* [`streaming_archiver`](#-barman--postgres--streaming_archiver)
* [`streaming_archiver_batch_size`](#-barman--postgres--streaming_archiver_batch_size)
* [`streaming_archiver_name`](#-barman--postgres--streaming_archiver_name)
* [`streaming_backup_name`](#-barman--postgres--streaming_backup_name)
* [`streaming_conninfo`](#-barman--postgres--streaming_conninfo)
* [`streaming_wals_directory`](#-barman--postgres--streaming_wals_directory)
* [`tablespace_bandwidth_limit`](#-barman--postgres--tablespace_bandwidth_limit)
* [`wal_retention_policy`](#-barman--postgres--wal_retention_policy)
* [`wals_directory`](#-barman--postgres--wals_directory)
* [`custom_lines`](#-barman--postgres--custom_lines)

##### <a name="-barman--postgres--manage_barman_server"></a>`manage_barman_server`

Data type: `Boolean`

Whether barman server config should be exported, default: `true`

Default value: `true`

##### <a name="-barman--postgres--host_group"></a>`host_group`

Data type: `String`



Default value: `$barman::host_group`

##### <a name="-barman--postgres--manage_dbuser"></a>`manage_dbuser`

Data type: `Boolean`

Whether db role should be managed, default: `true`

Default value: `true`

##### <a name="-barman--postgres--manage_ssh_host_keys"></a>`manage_ssh_host_keys`

Data type: `Boolean`



Default value: `$barman::manage_ssh_host_keys`

##### <a name="-barman--postgres--wal_level"></a>`wal_level`

Data type: `String`



Default value: `'archive'`

##### <a name="-barman--postgres--barman_user"></a>`barman_user`

Data type: `String`



Default value: `$barman::user`

##### <a name="-barman--postgres--barman_dbname"></a>`barman_dbname`

Data type: `String`

Name of the barman DB

Default value: `$barman::dbname`

##### <a name="-barman--postgres--barman_dbuser"></a>`barman_dbuser`

Data type: `String`



Default value: `$barman::dbuser`

##### <a name="-barman--postgres--barman_home"></a>`barman_home`

Data type: `String`



Default value: `$barman::home`

##### <a name="-barman--postgres--manage_cron"></a>`manage_cron`

Data type: `Boolean`



Default value: `true`

##### <a name="-barman--postgres--cron_user"></a>`cron_user`

Data type: `String`



Default value: `'root'`

##### <a name="-barman--postgres--backup_mday"></a>`backup_mday`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-barman--postgres--backup_wday"></a>`backup_wday`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-barman--postgres--backup_hour"></a>`backup_hour`

Data type: `Integer`



Default value: `4`

##### <a name="-barman--postgres--backup_minute"></a>`backup_minute`

Data type: `Integer`



Default value: `0`

##### <a name="-barman--postgres--password"></a>`password`

Data type: `Barman::Password`



Default value: `undef`

##### <a name="-barman--postgres--server_address"></a>`server_address`

Data type: `String`



Default value: `$facts['networking']['fqdn']`

##### <a name="-barman--postgres--server_port"></a>`server_port`

Data type: `Integer`



Default value: `5432`

##### <a name="-barman--postgres--postgres_server_id"></a>`postgres_server_id`

Data type: `String`



Default value: `$facts['networking']['hostname']`

##### <a name="-barman--postgres--postgres_user"></a>`postgres_user`

Data type: `String`



Default value: `'postgres'`

##### <a name="-barman--postgres--ensure"></a>`ensure`

Data type: `String`



Default value: `'present'`

##### <a name="-barman--postgres--conf_template"></a>`conf_template`

Data type: `String`



Default value: `'barman/server.conf.erb'`

##### <a name="-barman--postgres--description"></a>`description`

Data type: `String`



Default value: `$name`

##### <a name="-barman--postgres--archiver"></a>`archiver`

Data type: `Boolean`



Default value: `$barman::archiver`

##### <a name="-barman--postgres--force_archive_mode"></a>`force_archive_mode`

Data type: `Optional[Enum['on', 'off', 'always']]`

Configure archive mode regardless of archiver settings

Default value: `undef`

##### <a name="-barman--postgres--archiver_batch_size"></a>`archiver_batch_size`

Data type: `Optional[Integer]`



Default value: `$barman::archiver_batch_size`

##### <a name="-barman--postgres--backup_directory"></a>`backup_directory`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-barman--postgres--backup_method"></a>`backup_method`

Data type: `Barman::BackupMethod`



Default value: `$barman::backup_method`

##### <a name="-barman--postgres--backup_options"></a>`backup_options`

Data type: `Barman::BackupOptions`



Default value: `$barman::backup_options`

##### <a name="-barman--postgres--recovery_options"></a>`recovery_options`

Data type: `Barman::RecoveryOptions`



Default value: `$barman::recovery_options`

##### <a name="-barman--postgres--bandwidth_limit"></a>`bandwidth_limit`

Data type: `Optional[Integer]`



Default value: `$barman::bandwidth_limit`

##### <a name="-barman--postgres--basebackups_directory"></a>`basebackups_directory`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-barman--postgres--basebackup_retry_sleep"></a>`basebackup_retry_sleep`

Data type: `Optional[Integer]`



Default value: `$barman::basebackup_retry_sleep`

##### <a name="-barman--postgres--basebackup_retry_times"></a>`basebackup_retry_times`

Data type: `Optional[Integer]`



Default value: `$barman::basebackup_retry_times`

##### <a name="-barman--postgres--check_timeout"></a>`check_timeout`

Data type: `Optional[Integer]`



Default value: `$barman::check_timeout`

##### <a name="-barman--postgres--compression"></a>`compression`

Data type: `Variant[String,Boolean]`



Default value: `$barman::compression`

##### <a name="-barman--postgres--custom_compression_filter"></a>`custom_compression_filter`

Data type: `Optional[String]`



Default value: `$barman::custom_compression_filter`

##### <a name="-barman--postgres--custom_decompression_filter"></a>`custom_decompression_filter`

Data type: `Optional[String]`



Default value: `$barman::custom_decompression_filter`

##### <a name="-barman--postgres--errors_directory"></a>`errors_directory`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-barman--postgres--immediate_checkpoint"></a>`immediate_checkpoint`

Data type: `Boolean`



Default value: `$barman::immediate_checkpoint`

##### <a name="-barman--postgres--incoming_wals_directory"></a>`incoming_wals_directory`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-barman--postgres--last_backup_maximum_age"></a>`last_backup_maximum_age`

Data type: `Barman::BackupAge`

Defines the time frame within which the latest backup must fall. If the latest
backup is older than this period, the barman check command will report an
error. If left empty (default), the latest backup is always considered valid.
The accepted format is "n {DAYS|WEEKS|MONTHS}", where n is an integer greater
than zero.

Default value: `$barman::last_backup_maximum_age`

##### <a name="-barman--postgres--last_wal_maximum_age"></a>`last_wal_maximum_age`

Data type: `Barman::BackupAge`

Defines the time frame within which the latest archived WAL file must fall. If
the latest WAL file is older than this period, the barman check command will
report an error. If left empty (default), the age of the WAL files is not
checked. Format is the same as last_backup_maximum_age.

Default value: `$barman::last_wal_maximum_age`

##### <a name="-barman--postgres--last_backup_minimum_size"></a>`last_backup_minimum_size`

Data type: `Barman::BackupSize`

Specifies the minimum acceptable size for the latest successful backup. If the
latest backup is smaller than this size, the barman check command will report
an error. If left empty (default), the latest backup is always considered
valid. The accepted format is "n {k|Ki|M|Mi|G|Gi|T|Ti}" and case-sensitive,
where n is an integer greater than zero, with an optional SI or IEC suffix.
k stands for kilo with k = 1000, while Ki stands for kilobytes Ki = 1024. The
rest of the options have the same reasoning for greater units of measure.

Default value: `$barman::last_backup_minimum_size`

##### <a name="-barman--postgres--minimum_redundancy"></a>`minimum_redundancy`

Data type: `Integer`



Default value: `$barman::minimum_redundancy`

##### <a name="-barman--postgres--network_compression"></a>`network_compression`

Data type: `Optional[Boolean]`



Default value: `$barman::network_compression`

##### <a name="-barman--postgres--parallel_jobs"></a>`parallel_jobs`

Data type: `Optional[Integer]`

- Number of parallel workers used to copy files during
backup or recovery. Requires backup mode = rsync.

Default value: `$barman::parallel_jobs`

##### <a name="-barman--postgres--path_prefix"></a>`path_prefix`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `$barman::path_prefix`

##### <a name="-barman--postgres--post_archive_retry_script"></a>`post_archive_retry_script`

Data type: `Optional[String]`



Default value: `$barman::post_archive_retry_script`

##### <a name="-barman--postgres--post_archive_script"></a>`post_archive_script`

Data type: `Optional[String]`



Default value: `$barman::post_archive_script`

##### <a name="-barman--postgres--post_backup_retry_script"></a>`post_backup_retry_script`

Data type: `Optional[String]`



Default value: `$barman::post_backup_retry_script`

##### <a name="-barman--postgres--post_backup_script"></a>`post_backup_script`

Data type: `Optional[String]`



Default value: `$barman::post_backup_script`

##### <a name="-barman--postgres--pre_archive_retry_script"></a>`pre_archive_retry_script`

Data type: `Optional[String]`



Default value: `$barman::pre_archive_retry_script`

##### <a name="-barman--postgres--pre_archive_script"></a>`pre_archive_script`

Data type: `Optional[String]`



Default value: `$barman::pre_archive_script`

##### <a name="-barman--postgres--pre_backup_retry_script"></a>`pre_backup_retry_script`

Data type: `Optional[String]`



Default value: `$barman::pre_backup_retry_script`

##### <a name="-barman--postgres--pre_backup_script"></a>`pre_backup_script`

Data type: `Optional[String]`



Default value: `$barman::pre_backup_script`

##### <a name="-barman--postgres--retention_policy"></a>`retention_policy`

Data type: `Barman::RetentionPolicy`



Default value: `$barman::retention_policy`

##### <a name="-barman--postgres--retention_policy_mode"></a>`retention_policy_mode`

Data type: `Barman::RetentionPolicyMode`



Default value: `$barman::retention_policy_mode`

##### <a name="-barman--postgres--reuse_backup"></a>`reuse_backup`

Data type: `Barman::ReuseBackup`



Default value: `$barman::reuse_backup`

##### <a name="-barman--postgres--slot_name"></a>`slot_name`

Data type: `Optional[String]`



Default value: `$barman::slot_name`

##### <a name="-barman--postgres--streaming_archiver"></a>`streaming_archiver`

Data type: `Boolean`



Default value: `$barman::streaming_archiver`

##### <a name="-barman--postgres--streaming_archiver_batch_size"></a>`streaming_archiver_batch_size`

Data type: `Optional[Integer]`



Default value: `$barman::streaming_archiver_batch_size`

##### <a name="-barman--postgres--streaming_archiver_name"></a>`streaming_archiver_name`

Data type: `Optional[String]`



Default value: `$barman::streaming_archiver_name`

##### <a name="-barman--postgres--streaming_backup_name"></a>`streaming_backup_name`

Data type: `Optional[String]`



Default value: `$barman::streaming_backup_name`

##### <a name="-barman--postgres--streaming_conninfo"></a>`streaming_conninfo`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-barman--postgres--streaming_wals_directory"></a>`streaming_wals_directory`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `$barman::streaming_wals_directory`

##### <a name="-barman--postgres--tablespace_bandwidth_limit"></a>`tablespace_bandwidth_limit`

Data type: `Optional[String]`



Default value: `$barman::tablespace_bandwidth_limit`

##### <a name="-barman--postgres--wal_retention_policy"></a>`wal_retention_policy`

Data type: `Barman::WalRetention`



Default value: `$barman::wal_retention_policy`

##### <a name="-barman--postgres--wals_directory"></a>`wals_directory`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-barman--postgres--custom_lines"></a>`custom_lines`

Data type: `Optional[String]`

DEPRECATED. Custom configuration directives (e.g. for custom compression). Defaults to empty.

Default value: `$barman::custom_lines`

## Defined types

### <a name="barman--archive_command"></a>`barman::archive_command`

=== Parameters

All parameters that are supported can be changed when the resource 'archive' is
created in the 'autoconfigure' class.

=== Authors

* Giuseppe Broccolo <giuseppe.broccolo@2ndQuadrant.it>
* Giulio Calacoci <giulio.calacoci@2ndQuadrant.it>
* Francesco Canovai <francesco.canovai@2ndQuadrant.it>
* Marco Nenciarini <marco.nenciarini@2ndQuadrant.it>
* Gabriele Bartolini <gabriele.bartolini@2ndQuadrant.it>
* Alessandro Grassi <alessandro.grassi@2ndQuadrant.it>

Many thanks to Alessandro Franceschi <al@lab42.it>

=== Copyright

Copyright 2012-2017 2ndQuadrant Italia

#### Parameters

The following parameters are available in the `barman::archive_command` defined type:

* [`postgres_server_id`](#-barman--archive_command--postgres_server_id)
* [`barman_user`](#-barman--archive_command--barman_user)
* [`barman_home`](#-barman--archive_command--barman_home)
* [`barman_server`](#-barman--archive_command--barman_server)
* [`barman_incoming_dir`](#-barman--archive_command--barman_incoming_dir)
* [`archive_cmd_type`](#-barman--archive_command--archive_cmd_type)

##### <a name="-barman--archive_command--postgres_server_id"></a>`postgres_server_id`

Data type: `String`

Tag for the PostgreSQL server. The default value (the host name)
should be fine, so you don't need to change this.

Default value: `'default'`

##### <a name="-barman--archive_command--barman_user"></a>`barman_user`

Data type: `String`

The default value is the one contained in the 'settings' class.

Default value: `$barman::user`

##### <a name="-barman--archive_command--barman_home"></a>`barman_home`

Data type: `String`

Home directory

Default value: `$barman::home`

##### <a name="-barman--archive_command--barman_server"></a>`barman_server`

Data type: `String`

The value is set when the resource is created
(in the 'autoconfigure' class).

Default value: `$title`

##### <a name="-barman--archive_command--barman_incoming_dir"></a>`barman_incoming_dir`

Data type: `Optional[Stdlib::Unixpath]`

The Barman WAL incoming directory. The default value will be
generated here to be something like
                        '<barman home>/<postgres_server_id>/incoming'

Default value: `undef`

##### <a name="-barman--archive_command--archive_cmd_type"></a>`archive_cmd_type`

Data type: `String`

The archive command to use, either rsync or barman-wal-archive,
                     defaults to rsync

Default value: `'rsync'`

### <a name="barman--server"></a>`barman::server`

NOTE: The resource is called in the 'postgres' class.
---

=== Authors

* Giuseppe Broccolo <giuseppe.broccolo@2ndQuadrant.it>
* Giulio Calacoci <giulio.calacoci@2ndQuadrant.it>
* Francesco Canovai <francesco.canovai@2ndQuadrant.it>
* Marco Nenciarini <marco.nenciarini@2ndQuadrant.it>
* Gabriele Bartolini <gabriele.bartolini@2ndQuadrant.it>
* Alessandro Grassi <alessandro.grassi@2ndQuadrant.it>

Many thanks to Alessandro Franceschi <al@lab42.it>

=== Copyright

Copyright 2012-2017 2ndQuadrant Italia

=== Parameters

Many of the main configuration parameters can ( and *must*) be passed in
order to perform overrides.

Postgres connection string. *Mandatory*.
Command to open an ssh connection to Postgres. *Mandatory*.
Whether this server is active in the barman configuration.
Name of the server
Ensure (or not) that single server Barman configuration files are
             created. The default value is 'present'. Just 'absent' or
             'present' are the possible settings.
path of the template file to build the Barman
                    configuration file.
Description of the configuration file: it is automatically
                  set when the resource is used.
Whether the log shipping backup mechanism is active or not.
Setting this option enables batch processing of WAL
                          files. The default processes all currently available
                          files.
Directory where backup data for a server will be placed.
Configure the method barman used for backup execution. If
                    set to rsync (default), barman will execute backup using the
                    rsync command. If set to postgres barman will use the
                    pg_basebackup command to execute the backup.
Behavior for backup operations: possible values are
                     exclusive_backup (default) and concurrent_backup.
The restore command to write in the recovery.conf.
                       Possible values are 'get-wal' and undef. Default: undef.
This option allows you to specify a maximum transfer rate
                      in kilobytes per second. A value of zero specifies no
                      limit (default).
Directory where base backups will be placed.
Number of seconds of wait after a failed copy,
                             before retrying Used during both backup and
                             recovery operations. Positive integer, default 30.
Number of retries of base backup copy, after an
                             error. Used during both backup and recovery
                             operations. Positive integer, default 0.
Maximum execution time, in seconds per server, for a barman
                    check command. Set to 0 to disable the timeout. Positive
                    integer, default 30.
Compression algorithm. Currently supports 'gzip' (default),
                  'bzip2', and 'custom'. Disabled if false.
Determines whether Barman should automatically create a replication slot if it’s
                   not already present for streaming WAL files.
                   One of 'auto' or 'manual' (default).
Customised compression algorithm applied to WAL
                                files.
Customised decompression algorithm applied to
                                  compressed WAL files; this must match the
                                  compression algorithm.
Directory that contains WAL files that contain an error.
Force the checkpoint on the Postgres server to
                           happen immediately and start your backup copy
                           process as soon as possible. Disabled if false
                           (default)
Directory where incoming WAL files are archived
                              into. Requires archiver to be enabled.
Minimum number of backups to be retained. Default 0.
This option allows you to enable data compression for
                          network transfers. Defaults to false.
One or more absolute paths, separated by colon, where Barman
                  looks for executable files.
Hook script launched after a WAL file is
                                archived by maintenance. Being this a retry hook
                                script, Barman will retry the execution of the
                                script until this either returns a SUCCESS (0),
                                an ABORT_CONTINUE (62) or an ABORT_STOP (63)
                                code. In a post archive scenario, ABORT_STOP has
                                currently the same effects as ABORT_CONTINUE.
Hook script launched after a WAL file is archived by
                          maintenance, after 'post_archive_retry_script'.
Hook script launched after a base backup. Being
                               this a retry hook script, Barman will retry the
                               execution of the script until this either returns
                               a SUCCESS (0), an ABORT_CONTINUE (62) or an
                               ABORT_STOP (63) code. In a post backup scenario,
                               ABORT_STOP has currently the same effects as
                               ABORT_CONTINUE.
Hook script launched after a base backup, after
                         'post_backup_retry_script'.
Hook script launched before a WAL file is
                               archived by maintenance, after
                               'pre_archive_script'. Being this a retry hook
                               script, Barman will retry the execution of the
                               script until this either returns a SUCCESS (0),
                               an ABORT_CONTINUE (62) or an ABORT_STOP (63)
                               code. Returning ABORT_STOP will propagate the
                               failure at a higher level and interrupt the WAL
                               archiving operation.
Hook script launched before a WAL file is archived by
			   maintenance.
Hook script launched before a base backup, after
                              'pre_backup_script'. Being this a retry hook
                              script, Barman will retry the execution of the
                              script until this either returns a SUCCESS (0), an
                              ABORT_CONTINUE (62) or an ABORT_STOP (63) code.
                              Returning ABORT_STOP will propagate the failure at
                              a higher level and interrupt the backup operation.
Hook script launched before a base backup.
Base backup retention policy, based on redundancy or
                       recovery window. Default empty (no retention enforced).
                       Value must be greater than or equal to the server
                       minimum redundancy level (if not is is assigned to
                       that value and a warning is generated).
Connection string for Barman to connect to the primary Postgres server during
                       a standby backup. Default: undef (disabled).
Can only be set to auto (retention policies are
                            automatically enforced by the barman cron command)
Incremental backup is a kind of full periodic backup which
                   saves only data changes from the latest full backup
                   available in the catalogue for a specific PostgreSQL
                   server. Disabled if false. Default false.
Physical replication slot to be used by the receive-wal
                command when streaming_archiver is set to on. Requires
                postgreSQL >= 9.4. Default: undef (disabled).
This option allows you to use the PostgreSQL's
                         streaming protocol to receive transaction logs from a
                         server. This activates connection checks as well as
                         management (including compression) of WAL files. If
                         set to off (default) barman will rely only on
                         continuous archiving for a server WAL archive
                         operations, eventually terminating any running
                         pg_receivexlog for the server.
This option allows you to activate batch
                                    processing of WAL files for the
                                    streaming_archiver process, by setting it to
                                    a value > 0. Otherwise, the traditional
                                    unlimited processing of the WAL queue is
                                    enabled.
Identifier to be used as application_name by the
                              receive-wal command. Only available with
                              pg_receivexlog >= 9.3. By default it is set to
                              barman_receive_wal.
Identifier to be used as application_name by the
                            pg_basebackup command. Only available with
                            pg_basebackup >= 9.3. By default it is set to
                            barman_streaming_backup.
Connection string used by Barman to connect to the
                         Postgres server via streaming replication protocol. By
                         default it is set to the same value as *conninfo*.
Directory where WAL files are streamed from the
                               PostgreSQL server to Barman.
This option allows you to specify a maximum
                                 transfer rate in kilobytes per second, by
                                 specifying a comma separated list of
                                 tablespaces (pairs TBNAME:BWLIMIT). A value of
                                 zero specifies no limit (default).
WAL archive logs retention policy. Currently, the
                           only allowed value for wal_retention_policy is the
                           special value main, that maps the retention policy
                           of archive logs to that of base backups.
Directory which contains WAL files.
DEPRECATED. Custom configuration directives (e.g. for
                   custom compression). Defaults to empty.

#### Examples

##### 

```puppet
barman::server { 'main':
  conninfo           => 'user=postgres host=server1 password=pg123',
  ssh_command        => 'ssh postgres@server1',
  compression        => 'bzip2',
  pre_backup_script  => '/usr/bin/touch /tmp/started',
  post_backup_script => '/usr/bin/touch /tmp/stopped',
  custom_lines       => '; something'
}
```

#### Parameters

The following parameters are available in the `barman::server` defined type:

* [`conninfo`](#-barman--server--conninfo)
* [`ssh_command`](#-barman--server--ssh_command)
* [`active`](#-barman--server--active)
* [`server_name`](#-barman--server--server_name)
* [`ensure`](#-barman--server--ensure)
* [`conf_template`](#-barman--server--conf_template)
* [`description`](#-barman--server--description)
* [`archiver`](#-barman--server--archiver)
* [`archiver_batch_size`](#-barman--server--archiver_batch_size)
* [`backup_directory`](#-barman--server--backup_directory)
* [`backup_method`](#-barman--server--backup_method)
* [`backup_options`](#-barman--server--backup_options)
* [`recovery_options`](#-barman--server--recovery_options)
* [`bandwidth_limit`](#-barman--server--bandwidth_limit)
* [`basebackups_directory`](#-barman--server--basebackups_directory)
* [`basebackup_retry_sleep`](#-barman--server--basebackup_retry_sleep)
* [`basebackup_retry_times`](#-barman--server--basebackup_retry_times)
* [`check_timeout`](#-barman--server--check_timeout)
* [`compression`](#-barman--server--compression)
* [`create_slot`](#-barman--server--create_slot)
* [`custom_compression_filter`](#-barman--server--custom_compression_filter)
* [`custom_decompression_filter`](#-barman--server--custom_decompression_filter)
* [`errors_directory`](#-barman--server--errors_directory)
* [`immediate_checkpoint`](#-barman--server--immediate_checkpoint)
* [`incoming_wals_directory`](#-barman--server--incoming_wals_directory)
* [`last_backup_maximum_age`](#-barman--server--last_backup_maximum_age)
* [`last_wal_maximum_age`](#-barman--server--last_wal_maximum_age)
* [`last_backup_minimum_size`](#-barman--server--last_backup_minimum_size)
* [`minimum_redundancy`](#-barman--server--minimum_redundancy)
* [`network_compression`](#-barman--server--network_compression)
* [`parallel_jobs`](#-barman--server--parallel_jobs)
* [`path_prefix`](#-barman--server--path_prefix)
* [`post_archive_retry_script`](#-barman--server--post_archive_retry_script)
* [`post_archive_script`](#-barman--server--post_archive_script)
* [`post_backup_retry_script`](#-barman--server--post_backup_retry_script)
* [`post_backup_script`](#-barman--server--post_backup_script)
* [`pre_archive_retry_script`](#-barman--server--pre_archive_retry_script)
* [`pre_archive_script`](#-barman--server--pre_archive_script)
* [`pre_backup_retry_script`](#-barman--server--pre_backup_retry_script)
* [`pre_backup_script`](#-barman--server--pre_backup_script)
* [`retention_policy`](#-barman--server--retention_policy)
* [`primary_conninfo`](#-barman--server--primary_conninfo)
* [`retention_policy_mode`](#-barman--server--retention_policy_mode)
* [`reuse_backup`](#-barman--server--reuse_backup)
* [`slot_name`](#-barman--server--slot_name)
* [`streaming_archiver`](#-barman--server--streaming_archiver)
* [`streaming_archiver_batch_size`](#-barman--server--streaming_archiver_batch_size)
* [`streaming_archiver_name`](#-barman--server--streaming_archiver_name)
* [`streaming_backup_name`](#-barman--server--streaming_backup_name)
* [`streaming_conninfo`](#-barman--server--streaming_conninfo)
* [`streaming_wals_directory`](#-barman--server--streaming_wals_directory)
* [`tablespace_bandwidth_limit`](#-barman--server--tablespace_bandwidth_limit)
* [`wal_retention_policy`](#-barman--server--wal_retention_policy)
* [`wals_directory`](#-barman--server--wals_directory)
* [`custom_lines`](#-barman--server--custom_lines)

##### <a name="-barman--server--conninfo"></a>`conninfo`

Data type: `String`



##### <a name="-barman--server--ssh_command"></a>`ssh_command`

Data type: `String`



##### <a name="-barman--server--active"></a>`active`

Data type: `Boolean`



Default value: `true`

##### <a name="-barman--server--server_name"></a>`server_name`

Data type: `Barman::ServerName`



Default value: `$title`

##### <a name="-barman--server--ensure"></a>`ensure`

Data type: `Enum['present', 'absent']`



Default value: `'present'`

##### <a name="-barman--server--conf_template"></a>`conf_template`

Data type: `String`



Default value: `'barman/server.conf.erb'`

##### <a name="-barman--server--description"></a>`description`

Data type: `String`



Default value: `$title`

##### <a name="-barman--server--archiver"></a>`archiver`

Data type: `Boolean`



Default value: `$barman::archiver`

##### <a name="-barman--server--archiver_batch_size"></a>`archiver_batch_size`

Data type: `Optional[Integer]`



Default value: `$barman::archiver_batch_size`

##### <a name="-barman--server--backup_directory"></a>`backup_directory`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-barman--server--backup_method"></a>`backup_method`

Data type: `Barman::BackupMethod`



Default value: `$barman::backup_method`

##### <a name="-barman--server--backup_options"></a>`backup_options`

Data type: `Barman::BackupOptions`



Default value: `$barman::backup_options`

##### <a name="-barman--server--recovery_options"></a>`recovery_options`

Data type: `Barman::RecoveryOptions`



Default value: `$barman::recovery_options`

##### <a name="-barman--server--bandwidth_limit"></a>`bandwidth_limit`

Data type: `Optional[Integer]`



Default value: `$barman::bandwidth_limit`

##### <a name="-barman--server--basebackups_directory"></a>`basebackups_directory`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-barman--server--basebackup_retry_sleep"></a>`basebackup_retry_sleep`

Data type: `Optional[Integer]`



Default value: `$barman::basebackup_retry_sleep`

##### <a name="-barman--server--basebackup_retry_times"></a>`basebackup_retry_times`

Data type: `Optional[Integer]`



Default value: `$barman::basebackup_retry_times`

##### <a name="-barman--server--check_timeout"></a>`check_timeout`

Data type: `Optional[Integer]`



Default value: `$barman::check_timeout`

##### <a name="-barman--server--compression"></a>`compression`

Data type: `Variant[String,Boolean]`



Default value: `$barman::compression`

##### <a name="-barman--server--create_slot"></a>`create_slot`

Data type: `Barman::CreateSlot`



Default value: `$barman::create_slot`

##### <a name="-barman--server--custom_compression_filter"></a>`custom_compression_filter`

Data type: `Optional[String]`



Default value: `$barman::custom_compression_filter`

##### <a name="-barman--server--custom_decompression_filter"></a>`custom_decompression_filter`

Data type: `Optional[String]`



Default value: `$barman::custom_decompression_filter`

##### <a name="-barman--server--errors_directory"></a>`errors_directory`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-barman--server--immediate_checkpoint"></a>`immediate_checkpoint`

Data type: `Boolean`



Default value: `$barman::immediate_checkpoint`

##### <a name="-barman--server--incoming_wals_directory"></a>`incoming_wals_directory`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-barman--server--last_backup_maximum_age"></a>`last_backup_maximum_age`

Data type: `Barman::BackupAge`

Defines the time frame within which the latest backup must fall. If the latest
backup is older than this period, the barman check command will report an
error. If left empty (default), the latest backup is always considered valid.
The accepted format is "n {DAYS|WEEKS|MONTHS}", where n is an integer greater
than zero.

Default value: `$barman::last_backup_maximum_age`

##### <a name="-barman--server--last_wal_maximum_age"></a>`last_wal_maximum_age`

Data type: `Barman::BackupAge`

Defines the time frame within which the latest archived WAL file must fall. If
the latest WAL file is older than this period, the barman check command will
report an error. If left empty (default), the age of the WAL files is not
checked. Format is the same as last_backup_maximum_age.

Default value: `$barman::last_wal_maximum_age`

##### <a name="-barman--server--last_backup_minimum_size"></a>`last_backup_minimum_size`

Data type: `Barman::BackupSize`

Specifies the minimum acceptable size for the latest successful backup. If the
latest backup is smaller than this size, the barman check command will report
an error. If left empty (default), the latest backup is always considered
valid. The accepted format is "n {k|Ki|M|Mi|G|Gi|T|Ti}" and case-sensitive,
where n is an integer greater than zero, with an optional SI or IEC suffix.
k stands for kilo with k = 1000, while Ki stands for kilobytes Ki = 1024. The
rest of the options have the same reasoning for greater units of measure.

Default value: `$barman::last_backup_minimum_size`

##### <a name="-barman--server--minimum_redundancy"></a>`minimum_redundancy`

Data type: `Optional[Integer]`



Default value: `$barman::minimum_redundancy`

##### <a name="-barman--server--network_compression"></a>`network_compression`

Data type: `Optional[Boolean]`



Default value: `$barman::network_compression`

##### <a name="-barman--server--parallel_jobs"></a>`parallel_jobs`

Data type: `Optional[Integer]`

- Number of parallel workers used to copy files during
backup or recovery. Requires backup mode = rsync.

Default value: `$barman::parallel_jobs`

##### <a name="-barman--server--path_prefix"></a>`path_prefix`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `$barman::path_prefix`

##### <a name="-barman--server--post_archive_retry_script"></a>`post_archive_retry_script`

Data type: `Optional[String]`



Default value: `$barman::post_archive_retry_script`

##### <a name="-barman--server--post_archive_script"></a>`post_archive_script`

Data type: `Optional[String]`



Default value: `$barman::post_archive_script`

##### <a name="-barman--server--post_backup_retry_script"></a>`post_backup_retry_script`

Data type: `Optional[String]`



Default value: `$barman::post_backup_retry_script`

##### <a name="-barman--server--post_backup_script"></a>`post_backup_script`

Data type: `Optional[String]`



Default value: `$barman::post_backup_script`

##### <a name="-barman--server--pre_archive_retry_script"></a>`pre_archive_retry_script`

Data type: `Optional[String]`



Default value: `$barman::pre_archive_retry_script`

##### <a name="-barman--server--pre_archive_script"></a>`pre_archive_script`

Data type: `Optional[String]`



Default value: `$barman::pre_archive_script`

##### <a name="-barman--server--pre_backup_retry_script"></a>`pre_backup_retry_script`

Data type: `Optional[String]`



Default value: `$barman::pre_backup_retry_script`

##### <a name="-barman--server--pre_backup_script"></a>`pre_backup_script`

Data type: `Optional[String]`



Default value: `$barman::pre_backup_script`

##### <a name="-barman--server--retention_policy"></a>`retention_policy`

Data type: `Barman::RetentionPolicy`



Default value: `$barman::retention_policy`

##### <a name="-barman--server--primary_conninfo"></a>`primary_conninfo`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-barman--server--retention_policy_mode"></a>`retention_policy_mode`

Data type: `Barman::RetentionPolicyMode`



Default value: `$barman::retention_policy_mode`

##### <a name="-barman--server--reuse_backup"></a>`reuse_backup`

Data type: `Barman::ReuseBackup`



Default value: `$barman::reuse_backup`

##### <a name="-barman--server--slot_name"></a>`slot_name`

Data type: `Optional[String]`



Default value: `$barman::slot_name`

##### <a name="-barman--server--streaming_archiver"></a>`streaming_archiver`

Data type: `Boolean`



Default value: `$barman::streaming_archiver`

##### <a name="-barman--server--streaming_archiver_batch_size"></a>`streaming_archiver_batch_size`

Data type: `Optional[Integer]`



Default value: `$barman::streaming_archiver_batch_size`

##### <a name="-barman--server--streaming_archiver_name"></a>`streaming_archiver_name`

Data type: `Optional[String]`



Default value: `$barman::streaming_archiver_name`

##### <a name="-barman--server--streaming_backup_name"></a>`streaming_backup_name`

Data type: `Optional[String]`



Default value: `$barman::streaming_backup_name`

##### <a name="-barman--server--streaming_conninfo"></a>`streaming_conninfo`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-barman--server--streaming_wals_directory"></a>`streaming_wals_directory`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-barman--server--tablespace_bandwidth_limit"></a>`tablespace_bandwidth_limit`

Data type: `Optional[String]`



Default value: `$barman::tablespace_bandwidth_limit`

##### <a name="-barman--server--wal_retention_policy"></a>`wal_retention_policy`

Data type: `Barman::WalRetention`



Default value: `$barman::wal_retention_policy`

##### <a name="-barman--server--wals_directory"></a>`wals_directory`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-barman--server--custom_lines"></a>`custom_lines`

Data type: `Optional[String]`



Default value: `$barman::custom_lines`

## Data types

### <a name="Barman--BackupAge"></a>`Barman::BackupAge`

Allowed backup age

Alias of `Optional[Pattern[/^[1-9][0-9]* (DAY|WEEK|MONTH)S?$/]]`

### <a name="Barman--BackupMethod"></a>`Barman::BackupMethod`

Barman backup methods

Alias of `Optional[Enum['rsync','postgres']]`

### <a name="Barman--BackupOptions"></a>`Barman::BackupOptions`

Barman backup options

Alias of `Optional[Enum['exclusive_backup', 'concurrent_backup']]`

### <a name="Barman--BackupSize"></a>`Barman::BackupSize`

Allowed backup size

Alias of `Optional[Pattern[/^[1-9][0-9]*( (k|Ki|M|Mi|G|Gi|T|Ti))?$/]]`

### <a name="Barman--CreateSlot"></a>`Barman::CreateSlot`

Allowed values for `create_slot` option

Alias of `Optional[Enum['manual', 'auto']]`

### <a name="Barman--LogLevel"></a>`Barman::LogLevel`

Allowed log levels

Alias of `Enum['DEBUG', 'INFO', 'WARNING', 'ERROR', 'CRITICAL']`

### <a name="Barman--Password"></a>`Barman::Password`

Allowed values for secrets

Alias of

```puppet
Optional[Variant[
    String,
    Sensitive[String],
    Integer
  ]]
```

### <a name="Barman--RecoveryOptions"></a>`Barman::RecoveryOptions`

Recovery options, currently only `get-wal` supported

Alias of `Optional[Enum['get-wal']]`

### <a name="Barman--RetentionPolicy"></a>`Barman::RetentionPolicy`

Backup's retention policy

Alias of `Optional[Pattern[/^(^$|REDUNDANCY [1-9][0-9]*|RECOVERY WINDOW OF [1-9][0-9]* (DAY|WEEK|MONTH)S?)$/]]`

### <a name="Barman--RetentionPolicyMode"></a>`Barman::RetentionPolicyMode`

Retention policy mode

Alias of `Optional[Enum['auto']]`

### <a name="Barman--ReuseBackup"></a>`Barman::ReuseBackup`

Methods for reusing backups

Alias of `Optional[Enum['off','link','copy']]`

### <a name="Barman--ServerName"></a>`Barman::ServerName`

Allowed characters for server name

Alias of `Pattern[/^[\w-]*$/]`

### <a name="Barman--WalRetention"></a>`Barman::WalRetention`

WAL retention

Alias of `Optional[Enum['main']]`

